routes/web.php
<?php

use App\Http\Controllers\Admin;
use App\Http\Controllers\Supplier;
use Illuminate\Routing\Controller;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Route;
use App\Http\Controllers\POSController;
use App\Http\Controllers\SiteController;
use App\Http\Controllers\Admin\UserController;
use App\Http\Controllers\Admin\OrderController;
use App\Http\Controllers\Admin\StockController;
use App\Http\Controllers\Admin\PurchaseController;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', [SiteController::class, 'index'])->name('index');
Route::get('/home', [SiteController::class, 'home'])
    ->name('home')
    ->middleware('auth');
Route::get('/404', [SiteController::class, 'notFound'])->name('404');

Route::controller(POSController::class)
    ->middleware('cashier')
    ->prefix('/pos')
    ->name('pos.')
    ->group(function () {
        Route::get('/', 'index')->name('index');
        Route::post('/select-customer', 'selectCustomer')->name('customer.select');
        Route::post('/new-customer', 'createCustomer')->name('customer.create');
        Route::post('/no-customer', 'emptyCustomer')->name('customer.none');

        Route::get('/order/{order}', 'order')->name('order');
        Route::post('/order/{order}/status', 'changeStatus')->name('status');
        Route::post('/order/{order}/products', 'addProduct')->name('products.store');
        Route::get('/order/{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
        Route::post('/order/{order}/quantity', 'updateQuantity')->name('quantity');
    });

Route::middleware(['auth', 'admin'])->prefix('/admin')->name('admin.')->group(function () {
    Route::get('/', [Admin\AdminController::class, 'index'])->name('index');

    //CRUD
    Route::resource('categories', Admin\CategoryController::class);
    Route::resource('suppliers', Admin\SupplierController::class);
    Route::resource('customers', Admin\CustomerController::class);

    Route::controller(Admin\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });

    Route::resource('products', Admin\ProductController::class);
    Route::get('batches/{batch}/products', [Admin\BatchController::class, 'products'])->name('batches.products.index');
    Route::post('batches/{batch}/products', [Admin\BatchController::class, 'addProduct'])->name('batches.products.store');
    Route::delete('batches/{batch}/products/{batchproduct}', [Admin\BatchController::class, 'deleteProduct'])->name('batches.products.destory');
    Route::resource('batches', Admin\BatchController::class);
    Route::resource('batchproducts', Admin\BatchProductController::class);
    Route::resource('stocks', Admin\StockController::class);

    Route::get('purchases/supplies', [Admin\PurchaseController::class, 'supplies'])->name('purchases.supplies.index');
    Route::get('purchases/{purchase}/approve', [Admin\PurchaseController::class, 'approve'])->name('purchases.supplies.approve');
    Route::delete('purchases/{purchase}/decline', [Admin\PurchaseController::class, 'decline'])->name('purchases.supplies.decline');
    Route::resource('purchases', Admin\PurchaseController::class);

    Route::resource('users', Admin\UserController::class);
    Route::prefix('orders')->name('orders.')->controller(Admin\OrderController::class)->group(function () {
        Route::post('{order}/status', 'changeStatus')->name('status');
        Route::post('{order}/products', 'addProduct')->name('products.store');
        Route::get('{order}/{product_order}/quantity', 'editQuantity')->name('products.quantity');
        Route::post('{order}/{product_order}/quantity', 'updateQuantity');
        Route::get('{order}/{product_order}/delete', 'deleteProduct')->name('products.delete');
    });
    Route::resource('orders', Admin\OrderController::class);

    Route::get('/reports', [Admin\ReportController::class, 'index'])->name('reports.index');
    Route::get('/reports/view', [Admin\ReportController::class, 'view'])->name('reports.view');
});


Route::middleware(['auth', 'supplier'])->prefix('/supplier')->name('supplier.')->group(function () {
    Route::get('/', [Supplier\SupplierController::class, 'index'])->name('index');


    //CRUD
    Route::controller(Supplier\ProductController::class)->name('products.')->group(function () {
        Route::get('products/{product}/variants', 'variants')->name('variants');
        Route::post('products/{product}/variants', 'addVariant')->name('variants');
        Route::delete('products/{product}/variants/{variant}', 'removeVariant')->name('variants.delete');
        Route::get('products/search', 'search')->name('search');
    });
    Route::resource('products', Supplier\ProductController::class);
    Route::resource('purchases', Supplier\PurchaseController::class);
    Route::resource('suppliers', SupplierController::class);
    Route::resource('variants', \App\Http\Controllers\Supplier\ProductController::class);
    // Route::resource('customers', CustomerController::class);
    // Route::resource('products', ProductController::class);
    // Route::resource('variants', VariantController::class);
});

app/Models/Purchase.php
<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;

class Purchase extends Model
{
    use HasFactory;

    protected $fillable = ['supplier_id', 'price', 'quantity', 'product_id', 'approved_at'];

    protected $casts = [
        'approved_at' => 'datetime',
    ];

    public function supplier()
    {
        return $this->belongsTo(Supplier::class);
    }

    public function product()
    {
        return $this->belongsTo(Product::class);
    }

    public function getTotalAttribute()
    {
        return $this->quantity * $this->price;
    }
}

app/Http/Controllers/Admin/SupplierController.php
<?php

namespace App\Http\Controllers\Admin;


use App\Models\User;
use App\Models\Supplier;
use Illuminate\Http\Request;
use App\Services\MediaService;
use Illuminate\Support\Facades\DB;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\Storage;


class SupplierController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $suppliers = Supplier::simplePaginate(5);

        return view('admin.suppliers.index', compact('suppliers'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        return view('admin.suppliers.create');
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => ['required', 'regex:/^[a-zA-z ]{1,}$/'],
            'email' => ['required', 'email', 'unique:users,email', 'regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix'],
            'password' => ['required'],
            'address' => ['required'],
            'phone' => ['required', 'numeric', 'digits:10', 'unique:suppliers,phonenumber', 'regex:/((98)|(97))(\d){8}/'],
            'shop_name' => ['required', 'regex:/^[a-zA-z ]{1,}$/'],
            'image' => ['nullable', 'image', 'mimes:png,jpeg,gif'],
        ]);

        if ($request->hasFile('image')) {
            $media_id = MediaService::upload($request->file('image'), "suppliers");
        }

        DB::transaction(function () use ($request, $media_id) {
            $user = User::create([
                'name' => $request->name,
                'email' => $request->email,
                'password' => bcrypt($request->password),
                'role' => 'Supplier',
            ]);

            Supplier::create([
                'name' => $request->name,
                'address' => $request->address,
                'phone' => $request->phone,
                'shop_name' => $request->shop_name,
                'user_id' => $user->id,
                'media_id' => $media_id ?? null,
            ]);
        });

        return redirect()->route('admin.suppliers.index')
            ->with('success', 'Supplier Created Successfully!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Supplier  $supplier
     * @return \Illuminate\Http\Response
     */
    public function show(Supplier $supplier)
    {
        return view('admin.suppliers.show', compact('supplier'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Supplier  $supplier
     * @return \Illuminate\Http\Response
     */
    public function edit(Supplier $supplier)
    {
        return view('admin.suppliers.edit', compact('supplier'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Supplier  $supplier
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Supplier $supplier)
    {
        $request->validate([
            'name' => ['required'],
            'email' => ['required', 'regex:/^([a-z0-9\+_\-]+)(\.[a-z0-9\+_\-]+)*@([a-z0-9\-]+\.)+[a-z]{2,6}$/ix'],
            'password' => ['required'],
            'address' => ['required'],
            'phone' => ['required'],
            'shop_name' => ['required'],

        ]);


        $supplier->update([
            'name' => $request->name,
            'email' => $request->email,
            'password' => $request->password,
            'address' => $request->address,
            'phone' => $request->phone,
            'shop_name' => $request->shop_name,

        ]);

        return redirect()->route('admin.suppliers.index')
            ->with('success', 'Supplier Updated Successfully!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Supplier  $supplier
     * @return \Illuminate\Http\Response
     */
    public function destroy(Supplier $supplier)
    {
        $supplier->delete();

        return redirect()->route('admin.suppliers.index')
            ->with('success', 'Supplier Deleted Successfully!');
    }
}

app/Http/Controllers/Supplier/ProductController.php
<?php

namespace App\Http\Controllers\Supplier;

use App\Models\Stock;
use App\Models\Product;
use App\Models\Variant;
use App\Models\Category;
use App\Models\Supplier;
use Illuminate\Http\Request;
use App\Services\MediaService;
use Illuminate\Support\Carbon;
use App\Http\Controllers\Controller;

class ProductController extends Controller
{

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $products = Product::withSum('stocks', 'quantity')
            ->where('supplier_id', auth()->user()->supplier->id)
            ->simplePaginate(10);

        return view('supplier.products.index', compact('products'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = Category::all();
        $suppliers = Supplier::all();

        return view('supplier.products.create', compact('categories', 'suppliers'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $request->validate([
            'name' => ['required'],
            'category_id' => ['required'],
            'code' => ['required'],
            'buying_price' => ['required'],
            'selling_price' => ['required'],
            'quantity' => ['required'],
            'buying_date' => ['required', 'date'],
            'image' => ['nullable', 'image', 'mimes:png,jpeg,gif'],
        ]);


        if ($request->hasFile('image')) {
            $media_id = MediaService::upload($request->file('image'), "products");
        }

        $product = Product::create([
            'name' => $request->name,
            'category_id' => $request->category_id,
            'supplier_id' => auth()->user()->supplier->id,
            'code' => $request->code,
            'buying_price' => $request->buying_price,
            'selling_price' => $request->selling_price,
            'quantity' => $request->quantity,
            'buying_date' => Carbon::parse($request->buying_date)->format('Y-m-d'),
            'media_id' => $media_id ?? null,
        ]);

        Stock::create([
            'product_id' => $product->id,
            'quantity' => $request->quantity,
        ]);



        return redirect()->route('supplier.products.index')
            ->with('success', 'Product Created Successfully!');
    }

    /**
     * Display the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function show(Product $product)
    {
        return view('supplier.products.show', compact('product'));
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function edit(Product $product)
    {
        $categories = Category::all();
        $suppliers = Supplier::all();
        return view('supplier.products.edit', compact('product', 'categories', 'suppliers'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, Product $product)
    {
        $request->validate([
            'name' => ['required'],
            'category_id' => ['required'],
            'code' => ['required'],
            'buying_price' => ['required'],
            'selling_price' => ['required'],
            'quantity' => ['required'],
            'buying_date' => ['required', 'date'],

        ]);


        $product->update([
            'name' => $request->name,
            'category_id' => $request->category_id,
            'code' => $request->code,
            'buying_price' => $request->buying_price,
            'selling_price' => $request->selling_price,
            'quantity' => $request->quantity,
            'buying_date' => Carbon::parse($request->buying_date)->format('Y-m-d'),

        ]);

        return redirect()->route('supplier.products.index')
            ->with('success', 'Product Updated Successfully!');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  \App\Models\Product  $product
     * @return \Illuminate\Http\Response
     */
    public function destroy(Product $product)
    {
        $product->delete();

        return redirect()->route('supplier.products.index')
            ->with('success', 'Product Deleted Successfully!');
    }

    public function search(Request $request)
    {
        if (empty($request->q)) {
            return redirect()->route('supplier.products.index');
        }

        $search = trim(strip_tags($request->q));

        $products = Product::where('name', 'LIKE', '%' . $search . '%')
            ->withSum('stocks', 'quantity')
            ->get();

        return view('supplier.products.search', compact('products', 'search'));
    }

    public function variants(Product $product)
    {
        $products = Variant::where('product_id', $product->id)
            ->orWhere('variant_id', $product->id)
            ->get();

        $all_products = Product::where('id', '!=', $product->id)->get();

        return view('supplier.products.variants', compact('products', 'all_products', 'product'));
    }

    public function addVariant(Request $request, Product $product)
    {
        $request->validate([
            'product_id' => ['required', 'exists:products,id'],
        ]);

        // Check if already exists
        $check1 = Variant::where([
            'product_id' => $product->id,
            'variant_id' => $request->product_id,
        ])->count();

        $check2 = Variant::where([
            'product_id' => $request->product_id,
            'variant_id' => $product->id,
        ])->count();

        if ($check1 != 0 || $check2 != 0) {
            return redirect()->route('supplier.products.variants', $product)
                ->with('error', 'Duplicate entry found! This product is already an variant!');
        }

        Variant::create([
            'product_id' => $product->id,
            'variant_id' => $request->product_id,
        ]);

        return redirect()->route('supplier.products.variants', $product)
            ->with('success', 'Variant added successfully!');
    }

    public function removeVariant(Product $product, Variant $variant)
    {
        $variant->delete();

        return redirect()->route('supplier.products.variants', $product)
            ->with('success', 'Variant has been removed successfully!');
    }
}

resources/views/supplier/purchases/create.blade.php
@extends('supplier.layout')
@section('title', 'Add Product Supply')

@section('content')

    <x-alert />

    <div class="card">
        <div class="card-header">
            <h3 class="card-title" style="font-size:1.3rem;line-height:1.8;
            font-weight:bold">
                Add New Product Supply</h3>
            <div class="card-tools">
                <a class="btn btn-outline-secondary" href="{{ route('supplier.purchases.index') }}">
                    <i class="fas fa-arrow-circle-left mr-2"></i>
                    Go Back
                </a>
            </div>
        </div>

        <div class="card-body">
            <form action="{{ route('supplier.purchases.store') }}" method="post" enctype="multipart/form-data">
                @csrf

                <x-input type="select" field="product_id" text="Product" :options="$products" />

                <x-input type="number" field="quantity" text="Quantity" />

                <x-input type="number" field="price" text="Unit Price" />

                <button class="btn btn-outline-secondary">
                    <i class="fas fa-save mr-2"></i>
                    Save
                </button>
            </form>
        </div>
    </div>

@endsection

resources/views/supplier/purchases/index.blade.php
@extends('supplier.layout')
@section('title', 'Supplied Products')

@section('content')

    <x-alert />

    <div class="card">
        <div class="card-header">
            <h3 class="card-title" style="font-size:1.3rem;line-height:1.8;
                    font-weight:bold">
                Supplied Products
            </h3>
            <div class="card-tools">
                <a class="btn btn-outline-secondary" href="{{ route('supplier.purchases.create') }}">
                    <i class="fas fa-plus-circle mr-2"></i>
                    Add New
                </a>
            </div>
        </div>

        <div class="card-body p-0">
            <table class="table table-bordered">
                <thead class="bg-secondary">
                    <tr>
                        <th>ID</th>
                        <th>Product</th>
                        <th>Price</th>
                        <th>Quantity</th>
                        <th>Total</th>
                        <th>Date</th>
                        <th>Approved</th>
                        <th>Action</th>
                    </tr>
                </thead>
                <tbody>
                    @foreach ($purchases as $purchase)
                        <tr>
                            <td>{{ $purchase->id }}</td>
                            <td>{{ $purchase->product->name }}</td>
                            <td>Rs. {{ $purchase->price }}</td>
                            <td>{{ $purchase->quantity }}</td>
                            <td>Rs. {{ $purchase->total }}</td>
                            <td>{{ $purchase->created_at }}</td>
                            <td>{{ $purchase->approved_at ?? 'No' }}</td>
                            <td>
                                <a class="btn btn-outline-secondary btn-sm"
                                    href="{{ route('supplier.purchases.show', $purchase) }}">
                                    <i class="fas fa-eye mr-2"></i>
                                    Show
                                </a>

                                {{-- <a class="btn btn-primary btn-sm" href="{{route('admin.purchases.edit',$purchase)}}">
                            <i class="fas fa-edit mr-2"></i>
                            Edit
                        </a> --}}

                                <form class="d-inline" action="{{ route('supplier.purchases.destroy', $purchase) }}"
                                    method="post">
                                    @csrf
                                    @method('DELETE')

                                    <button class="btn btn-outline-danger btn-sm">
                                        <i class="fas fa-trash mr-2"></i>
                                        Delete
                                    </button>
                                </form>
                            </td>
                        </tr>
                    @endforeach
                </tbody>
            </table>
            @if (count($purchases) == 0)
                <div class="alert alert-warning text-center mb-0">
                    No Items Found!
                </div>
            @endif
            <div class="card-fotter">
                {{ $purchases->links() }}
            </div>
        </div>
    </div>

@endsection

resources/views/supplier/purchases/show.blade.php
@extends('supplier.layout')

@section('title', 'Product Supply Details')

@section('content')

    <x-alert />

    <div class="card">
        <div class="card-header">

            <h3 class="card-title" style="font-size: 1.5rem;line-height:1.8;font-weight:bold">
                Product Supply Details
            </h3>

            <div class="card-tools">
                <a class="btn btn-outline-secondary" href="{{ route('supplier.purchases.index') }}">
                    <i class="fas fa-arrow-circle-left mr-2"></i>
                    Go Back
                </a>
            </div>

        </div>

        <div class="card-body p-0">
            <table class="table table-bordered table-striped">
                <tr>
                    <th style="width: 20%">ID</th>
                    <td>{{ $purchase->id }}</td>

                </tr>
                <tr>
                    <th>Product</th>
                    <td>{{ $purchase->product->name }}</td>

                </tr>
                <tr>
                    <th>Quantity</th>
                    <td>{{ $purchase->quantity }}</td>

                </tr>
                <tr>
                    <th>Unit Price</th>
                    <td>Rs. {{ $purchase->price }}</td>
                </tr>
                <tr>
                    <th>Total Price</th>
                    <td>Rs. {{ $purchase->total }}</td>
                </tr>
                <tr>
                    <th>Created</th>
                    <td>{{ $purchase->created_at }}</td>
                </tr>
                <tr>
                    <th>Approved</th>
                    <td>{{ $purchase->approved_at ?? 'No' }}</td>
                </tr>
                <tr>
                    <th>Updated</th>
                    <td>{{ $purchase->updated_at }}</td>

                </tr>
            </table>

        </div>

    </div>

@endsection